#!/usr/bin/ruby

# file: planner_template.rb

require 'nokorexi'

module LIBRARY
  
  def generate_webpage(xml, xsl)
    
    # transform the xml to html
    doc = Nokogiri::XML(xml)
    xslt  = Nokogiri::XSLT(xsl)
    xslt.transform(doc).to_s   
  end

  def fetch_file(s)
    RXFHelper.read(s).first
  end
end

class PlannerTemplate
  include LIBRARY
  
  
  def initialize(src, template: 'default')
    
    @xml = fetch_file src
    @xmldoc = Rexle.new(@xml)   
    @template = template 
        
  end
  
  def to_html()
    xsl    = fetch_file File.join(@template, 'planner.xsl')
    @html = generate_webpage(@xml, xsl)
  end
  
  def to_xml(options)
    Rexle.new(@xml).xml(options)
  end
  
  protected
  
  def fetch_css()
    
    %w(layout.css style.css).map do |filename|
      fetch_file File.join(@template, filename)
    end

  end
  
end
